'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-- CreateStats.vbs and CreateStats.asp
'-- 
'-- This script Generate the usage statistics for each IIS web site configured 
'-- on the computer using Webalizer.
'--
'-- If you use or extend these scripts, I would like to hear from you
'-- tom@tomspeirs.com
'--
'-- Based on VBS Script 'Stats.vbs' by Author: Cdric Caron <Cedric.Caron@urbanet.ch>
'-- I hope you don't mind me porting your Code to Webalizer and ASP.
'--
'-- Webazlizer ASP and VBSCRIPT, For IISVersion 'CreateStats.vbs' and 'CreateStats.asp' By Tom Speirs (tom@tomspeirs.com)
'-- History:
'--		5.May.2002: Version 1.11.
'--		2.January.2002: Version 1.01.
'--              
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'--		Instructions for the ASP version.
'--    Create a Directory 'Webalizer' in your Root Web. e.g C:\inetpub\wwwroot\webalizer
'--    Copy this Script (optionally with Webalizer for Win32) to your wwwroot directory
'--    In IIS Adminstration - create an Application for the Directory. 
'--    Running with Low Protection (IIS Service) (This will not work otherwise)
'--    Ensure the user running the ASP page has Administrator rights.
'--    You can do this under the Directory Security properties in IIS Manager
'--    For the Webalizer directory. Select 'Edit' Authentication/Anonymous Access Control.
'--    Then either change the account used for anonymous access to an Administrator account
'--    or diable anonymous access, enable Windows authentication, and when 
'--    accessing the page - login as an Administrator (This is safest for Production Servers)
'--
'--    You also need to Configure the App options for the ISS Application for the Webalizer Dir
'--    to have a greater timeout. For example, if you are processing half a years logs
'--    for a busy server, you should configure this for about 10 Minutes
'--    (600 seconds). Although it could take longer, depending on the size of Log Files
'--    and the speed of your Server.
'--    
'--    The page runs the Windows Convlog utility first, to ensure your logs
'--    are in a suitable format for Webalizer to process.
'--
'--    If you have Webalizer installed in another directory other than the location of
'--    this page, change the variable webalizercommand below
'--    I have tested this on Win2k Pro SP2, Win2k Adv Server SP2, and NT4 Server SP6a.
'--    only in IE 5.5 SP2 I am afraid. Although I can't see that it will have problems with anything else.
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'--		Instructions for the VBS version.
'--    Set the Date range using the DateStart and DateEnd variables
'--    Set the WebalizerCommand Variable to where webalizer.exe is located
'--    Just ensure you are logged in as an Administrator
'--    and your Virus Software won't stop VBS Scripts running,
'--    and run the script. Select VerboseMode to true if you have problems.
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------


verboseMode = false
statsFolder = "stats" 
convlogfolder="convlog"
webalizercommand = "D:\Inetpub\wwwroot\-Source-Addins-Exts-\-source_addins\Webalizer\webalizer.exe"


datestart=#01/01/2000#
dateend=#01/01/2007#






set objW3SVC = getobject("IIS://LOCALHOST/W3SVC")
Set WshShell = CreateObject("WScript.Shell")


	'--------------------------------------
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set WshNetwork = CreateObject("WScript.Network")
	
	'--------------------------------------	


	'--------------------------------------
	For Each objSITE In objW3SVC
		If objSITE.class = "IIsWebServer" Then

         

			For Each objVDIR In objSITE
				If objVDIR.class = "IIsWebVirtualDir" Then
					if fso.FolderExists(objVDIR.Path) AND fso.FolderExists(WshShell.ExpandEnvironmentStrings(objSITE.LogFileDirectory) & "\W3SVC" & objSITE.Name) then
					    Stats WshNetwork.ComputerName, objSITE.Servercomment, objVDIR.Path, WshShell.ExpandEnvironmentStrings(objSITE.LogFileDirectory) & "\W3SVC" & objSITE.Name
					End If
				End If
			Next
		End If
	Next

wscript.echo "Complete.."




Sub Stats(sname, name, sitepath, logpath)


	If verboseMode = True Then
		wscript.echo "Generating statistics for: " & sname & "  -  " & name 
for each ipport in objsite.serverbindings
if left(ipport,1)=":" then
	wscript.echo "http://" & sname & mid(ipport,1, len(ipport)-1) & "/stats/index.html"
else
	wscript.echo "http://" & mid(ipport,1, len(ipport)-1) & "/stats/index.html"
end if




next

		wscript.echo Chr(9) & "Path: " & sitepath 
		wscript.echo Chr(9) & "Log: " & logpath 
	'End If
end if	


	' Create the destination folder


	




		cmd =sitepath & "\" & statsFolder & "\webalizer.current"
		if fso.fileExists(cmd) then
		'wscript.echo cmd	
		'WshShell.Run cmd, 0, True
		fso.deletefile cmd
		end if

		cmd =sitepath & "\" & statsFolder & "\webalizer.hist"
		if fso.fileExists(cmd) then
		'wscript.echo cmd	
		'WshShell.Run cmd, 0, True
		fso.deletefile cmd
		end if


		
	If fso.FolderExists(sitepath & "\" & statsFolder) = False Then
		fso.CreateFolder(sitepath & "\" & statsFolder)
	End If





If fso.FolderExists(logpath & "\" & convlogfolder) = True Then
		fso.deletefolder(logpath & "\" & convlogfolder)
End If
		If fso.FolderExists(logpath & "\" & convlogfolder) = False Then
			fso.CreateFolder(logpath & "\" & convlogfolder)
		End If
	


' --------------------
if verbosemode=true then

wscript.echo "Converting Log Files - Pass 1" 
end if

for lyear=2000 to 2002
for lmonth= 1 to 12
for lday=1 to 32


if dateserial(lyear,lmonth,lday)>=datestart AND dateserial(lyear,lmonth,lday)<=dateend then
if fso.fileexists(logpath & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log") then

		cmd="convlog -ie -o " & chr(34) & logpath & "\" & convlogfolder & chr(34) & " "
		cmd=cmd & Chr(34) & logpath & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log" & chr(34)


if verbosemode=true then
wscript.echo "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log, "	
end if
		WshShell.Run cmd, 0, True

end if
end if
next
next
next
' --------------------
if verbosemode=true then

wscript.echo "Converting Log Files - Pass 2" 
end if
for lyear=2000 to 2002
for lmonth= 1 to 12
for lday=1 to 32
if dateserial(lyear,lmonth,lday)>=datestart AND dateserial(lyear,lmonth,lday)<=dateend then
if fso.fileexists(logpath & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log") then

		cmd="convlog -in -o " & chr(34) & logpath & "\" & convlogfolder & chr(34) & " "
		cmd=cmd & Chr(34) & logpath & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log" & chr(34)



if verbosemode=true then
wscript.echo "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log, "	
end if
		WshShell.Run cmd, 0, True
end if
end if
next
next
next
' --------------------
if verbosemode=true then

wscript.echo "Converting Log Files - Pass 3" 
end if

for lyear=2000 to 2002
for lmonth= 1 to 12
for lday=1 to 32
if dateserial(lyear,lmonth,lday)>=datestart AND dateserial(lyear,lmonth,lday)<=dateend then
if fso.fileexists(logpath & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log") then

		cmd="convlog -ii -o " & chr(34) & logpath & "\" & convlogfolder & chr(34) & " "
		cmd=cmd & Chr(34) & logpath & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log" & chr(34)

if verbosemode=true then
wscript.echo "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log, "	
end if		

		WshShell.Run cmd, 0, True	

end if
end if
next
next
next

' --------------------



if verbosemode=true then

end if		


if verbosemode=true then
wscript.echo "Creating Webalizer Statistics for :- " 
end if

for lyear=2000 to 2002
for lmonth= 1 to 12
for lday=1 to 32





if fso.fileexists(logpath & "\" & convlogfolder & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log.ncsa") then
if dateserial(lyear,lmonth,lday)>=datestart AND dateserial(lyear,lmonth,lday)<=dateend then

	if cint(lastlogday)>cint(lday) then
	

	cmd =sitepath & "\" & statsFolder & "\webalizer.current"
		'response.write cmd	
		'WshShell.Run cmd, 0, True
		if fso.fileexists(cmd) then
		if verbosemode=true then
 	  wscript.echo "Deleting webalizer.current"
  	 end if

			fso.deletefile (cmd)
		End If
	End if
	lastlogday=lday
		param = " -p -o " & Chr(34) & sitepath & "\" & statsFolder & Chr(34)
		param=param & " " & Chr(34) & logpath & "\" & convlogfolder & "\" & "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log.ncsa" & Chr(34) 
		
		cmd = Chr(34) & webalizerCommand & Chr(34) & param
if verbosemode=true then
		wscript.echo "ex" & right(lyear,2) & right("0" & lmonth,2) & right ("0" & lday,2) & ".log.ncsa" & ", "
end if

		WshShell.run cmd, 0, True
end if
end if

		Next
		Next
		Next

if verbosemode=true then

end if
End Sub


